package com.icloud.server.payutils.dto;

import lombok.Data;

import javax.persistence.Column;
import java.io.Serializable;
import java.util.Date;

/**
 * 基础实体对象
 *
 * @author
 */
@Data
public abstract class BaseDO implements Serializable {

    /**
     * 创建时间
     */

    @Column(name = "createTime")
    private Date createtime;
    /**
     * 最后更新时间
     */
    @Column(name = "updateTime")
    private Date updatetime;
    /**
     * 创建者，目前使用 SysUser 的 id 编号
     *
     * 使用 String 类型的原因是，未来可能会存在非数值的情况，留好拓展性。
     */
    @Column(name = "creator")
    private String creator;
    /**
     * 更新者，目前使用 SysUser 的 id 编号
     *
     * 使用 String 类型的原因是，未来可能会存在非数值的情况，留好拓展性。
     */
    @Column(name = "updater")
    private String updater;
    /**
     * 是否删除
     */
    @Column(name = "deleted")
    private Boolean deleted;

}
